import 'reflect-metadata';
import { Context } from './base_context_class';
import { Application } from '../framework';
export declare function isGeneratorFunction(fn: any): boolean;
export declare function isAsyncFunction(fn: any): boolean;
export declare type MethodType = 'head' | 'options' | 'get' | 'put' | 'patch' | 'post' | 'delete' | 'all' | 'resources' | 'register' | 'redirect';
export interface RouterMetadataType<ExtType = any> {
    name?: string;
    method?: MethodType | MethodType[];
    url?: string | RegExp | string[] | RegExp[] | ((app: Application) => string);
    description?: string;
    beforeMiddleware?: GetMiddlewareType[];
    afterMiddleware?: GetMiddlewareType[];
    extInfo?: ExtType;
    onError?: (ctx: Context, error: Error) => void;
}
export declare type GetMiddlewareType = (app: Application) => (Function | Function[]);
export interface RouterType<ExtType = any> extends RouterMetadataType<ExtType> {
    typeClass: any;
    typeGlobalName: string;
    functionName: string;
    paramTypes: {
        name: string;
        type: any;
    }[];
    returnType: any;
    call: () => (ctx: Context) => any;
}
export declare function FromCustom(custom: (ctx: Context, name: string) => any): ParameterDecorator;
export declare function FromBody(paramName?: string): ParameterDecorator;
export declare function FromParam(paramName?: string): ParameterDecorator;
export declare function FromQuery(paramName?: string): ParameterDecorator;
export declare function beforeMiddware(middwares: GetMiddlewareType | GetMiddlewareType[]): MethodDecorator;
export declare function afterMiddware(middwares: GetMiddlewareType | GetMiddlewareType[]): MethodDecorator;
export declare function routerMetadata<T = any>(data?: RouterMetadataType<T>): MethodDecorator;
export declare function getRouters<ExtType = any>(): RouterType<ExtType>[];
